/* code03e8.c - SysAppLaunch handler
   Copyright  1999 Mitch Blevins
   distributed under the GNU GPL.
   Based on LinkHistoryHack by Ben Darnell <dgdarnel@unity.ncsu.edu>
   Based on SampleHack by Roger Chaplin <foursquaredev@att.net>
*/

#include <Pilot.h>
#include <FeatureMgr.h>
#include <SysEvtPrv.h>
#include "fanfHack.h"
#include "fanfHackRsc.h"



// This is the code that will be called whenever ANY app calls EvtGetEvent,
// and myhack is enabled in HackMaster. HackMaster is not smart about the
// content of this file; it will simply jump to the first executable statement
// in this file. If you need helper functions, prototype them above, and
// define them AFTER the trap patch.
Err MySysAppLaunch(UInt cardNo, LocalID dbID, UInt launchFlags, Word cmd,
                    Ptr cmdPBP, DWord *resultP) {
   DWord temp;
   Err (*oldTrap)(UInt, LocalID, UInt, Word, Ptr, DWord*);
   Err err;
   UInt newCN;
   LocalID newDBID;
   ULong creatorID;
   DmSearchStateType searchstate;

   // get the address of the old SysAppLaunch() from HackMaster
   FtrGet(MYCRID, 0x3e8, &temp);
   // set the function pointer to the old trap
   oldTrap = (Err (*)(UInt, LocalID, UInt, Word, Ptr, DWord*)) temp;

   if (cmd == sysAppLaunchCmdGoTo) {
        err = 0;
        err = DmDatabaseInfo(cardNo, dbID, NULL, NULL, NULL, NULL, NULL, NULL,
                       NULL, NULL, NULL, NULL, &creatorID);
        if (!err) {
            if (sysFileCDatebook == creatorID) {
                err = DmGetNextDatabaseByTypeCreator(true, &searchstate,
                                'appl', 'Actn', true, &newCN, &newDBID);
                if (!err) {
                    ((GoToParamsPtr)cmdPBP)->matchCustom = 0; /*Meeting*/
                    cardNo = newCN;
                    dbID = newDBID;
                }
            }
        }
   }
   return oldTrap(cardNo, dbID, launchFlags, cmd, cmdPBP, resultP);
}

